Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zflx.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zflx.F90	(revision 2037)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zflx.F90	(revision 2038)
@@ -75,5 +75,5 @@
       REAL(wp) ::   zph, zah2, zbot, zdic, zalk, zsch_o2, zalka, zsch_co2
       REAL(wp), DIMENSION(jpi,jpj) ::   zkgco2, zkgo2, zh2co3
-#if defined key_trc_diaadd && defined key_iomput
+#if defined key_diatrc && defined key_iomput
       REAL(wp), DIMENSION(jpi,jpj) ::  zcflx, zoflx, zkg, zdpco2, zdpo2
 #endif
@@ -138,5 +138,5 @@
             ! Compute the piston velocity for O2 and CO2
             zkgwan = 0.3 * zws  + 2.5 * ( 0.5246 + 0.016256 * ztc + 0.00049946  * ztc2 )
-# if defined key_off_degrad
+# if defined key_degrad
             zkgwan = zkgwan * xconv * ( 1.- fr_i(ji,jj) ) * tmask(ji,jj,1) * facvol(ji,jj,1)
 #else
@@ -169,5 +169,5 @@
             tra(ji,jj,1,jpoxy) = tra(ji,jj,1,jpoxy) + ( zfld16 - zflu16 ) / fse3t(ji,jj,1)
 
-#if defined key_trc_diaadd 
+#if defined key_diatrc 
             ! Save diagnostics
 #  if ! defined key_iomput
@@ -228,5 +228,5 @@
       ENDIF
 
-# if defined key_trc_diaadd && defined key_iomput
+# if defined key_diatrc && defined key_iomput
       CALL iom_put( "Cflx" , zcflx  )
       CALL iom_put( "Oflx" , zoflx  )
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zlys.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zlys.F90	(revision 2037)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zlys.F90	(revision 2038)
@@ -65,5 +65,5 @@
       REAL(wp) ::   zomegaca, zexcess, zexcess0
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zco3
-#if defined key_trc_dia3d && defined key_iomput
+#if defined key_diatrc && defined key_iomput
       REAL(wp) ::   zrfact2
       REAL(wp), DIMENSION(jpi,jpj,jpk) :: zcaldiss
@@ -76,5 +76,5 @@
       zco3(:,:,:) = 0.
 
-# if defined key_trc_dia3d && defined key_iomput
+# if defined key_diatrc && defined key_iomput
       zcaldiss(:,:,:) = 0.
 # endif
@@ -146,5 +146,5 @@
                !       (ACCORDING TO THIS FORMULATION ALSO SOME PARTICULATE
                !       CACO3 GETS DISSOLVED EVEN IN THE CASE OF OVERSATURATION)
-# if defined key_off_degrad
+# if defined key_degrad
               zdispot = kdca * zexcess * trn(ji,jj,jk,jpcal) * facvol(ji,jj,jk)
 # else
@@ -160,5 +160,5 @@
               tra(ji,jj,jk,jpdic) = tra(ji,jj,jk,jpdic) +      zremco3
 
-# if defined key_trc_dia3d && defined key_iomput
+# if defined key_diatrc && defined key_iomput
               zcaldiss(ji,jj,jk) = zremco3  ! calcite dissolution
 # endif
@@ -167,5 +167,5 @@
       END DO
 
-# if defined key_trc_diaadd &&  defined key_trc_dia3d
+# if defined key_diatrc
 #  if ! defined key_iomput
       trc3d(:,:,:,jp_pcs0_3d    ) = hi  (:,:,:)          * tmask(:,:,:)
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zmeso.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zmeso.F90	(revision 2037)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zmeso.F90	(revision 2038)
@@ -74,5 +74,5 @@
       REAL(wp),DIMENSION(jpi,jpj,jpk) :: zgrazfff,zgrazffe
       CHARACTER (len=25) :: charout
-#if defined key_trc_diaadd && defined key_trc_dia3d && defined key_iomput
+#if defined key_diatrc && defined key_iomput
       REAL(wp) :: zrfact2
 #endif
@@ -102,5 +102,5 @@
 
                zcompam = MAX( ( trn(ji,jj,jk,jpmes) - 1.e-9 ), 0.e0 )
-# if defined key_off_degrad
+# if defined key_degrad
                zfact   = zstep * tgfunc(ji,jj,jk) * zcompam * facvol(ji,jj,jk)
 # else
@@ -140,5 +140,5 @@
 
                zgraze2 = grazrat2 * zstep * Tgfunc2(ji,jj,jk) * zdenom    &
-# if defined key_off_degrad
+# if defined key_degrad
                   &     * facvol(ji,jj,jk)          &
 # endif
@@ -168,5 +168,5 @@
 !    ----------------------------------
 # if ! defined key_kriest
-#   if ! defined key_off_degrad
+#   if ! defined key_degrad
                zgrazffe(ji,jj,jk) = grazflux * zstep * wsbio4(ji,jj,jk)          &
                   &                 * tgfunc2(ji,jj,jk) * trn(ji,jj,jk,jpgoc) * trn(ji,jj,jk,jpmes)
@@ -181,5 +181,5 @@
 !!               zgrazffe(ji,jj,jk) = 0.5 * 1.3e-2 / 5.5e-7 * 0.3 * zstep * wsbio3(ji,jj,jk)     &
 !!                  &     * tgfunc(ji,jj,jk) * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jpmes)    &
-#  if defined key_off_degrad
+#  if defined key_degrad
 !!                  &     * facvol(ji,jj,jk)          &
 #  endif
@@ -187,5 +187,5 @@
 !!--------------------------- KRIEST3 -------------------------------------------
 
-#  if ! defined key_off_degrad
+#  if ! defined key_degrad
               zgrazffe(ji,jj,jk) = grazflux * zstep * wsbio3(ji,jj,jk)     &
                   &                * tgfunc2(ji,jj,jk) * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jpmes)
@@ -202,5 +202,5 @@
       END DO
       
-#if defined key_trc_dia3d
+#if defined key_diatrc
       ! Total grazing ( grazing by microzoo is already computed in p4zmicro ) 
       grazing(:,:,:) = grazing(:,:,:) + (  zgrazd  (:,:,:) + zgrazz  (:,:,:) + zgrazn(:,:,:) &
@@ -281,5 +281,5 @@
 
                zprcaca = xfracal(ji,jj,jk) * unass2 * zgrazn(ji,jj,jk)
-#if defined key_trc_dia3d
+#if defined key_diatrc
                prodcal(ji,jj,jk) = prodcal(ji,jj,jk) + zprcaca  ! prodcal=prodcal(nanophy)+prodcal(microzoo)+prodcal(mesozoo)
 #endif
@@ -314,5 +314,5 @@
       END DO
       !
-#if defined key_trc_diaadd && defined key_trc_dia3d && defined key_iomput
+#if defined key_diatrc && defined key_iomput
       zrfact2 = 1.e3 * rfact2r
       ! Total grazing of phyto by zoo
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zmicro.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zmicro.F90	(revision 2037)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zmicro.F90	(revision 2038)
@@ -84,5 +84,5 @@
       zgrazpf(:,:,:) = 0.
 
-#if defined key_trc_dia3d
+#if defined key_diatrc
       grazing(:,:,:) = 0.  !: Initialisation of  grazing
 #endif
@@ -95,5 +95,5 @@
 
                zcompaz = MAX( ( trn(ji,jj,jk,jpzoo) - 1.e-9 ), 0.e0 )
-# if defined key_off_degrad
+# if defined key_degrad
                zfact   = zstep * tgfunc(ji,jj,jk) * zcompaz *facvol(ji,jj,jk)
 # else
@@ -132,5 +132,5 @@
 
                zgraze = grazrat * zstep * tgfunc(ji,jj,jk)     &
-# if defined key_off_degrad
+# if defined key_degrad
                   &      * facvol(ji,jj,jk)         &
 # endif
@@ -155,5 +155,5 @@
       END DO
       
-#if defined key_trc_dia3d
+#if defined key_diatrc
       ! Grazing by microzooplankton
       grazing(:,:,:) = grazing(:,:,:) + zgrazp(:,:,:) + zgrazm(:,:,:) + zgrazsd(:,:,:) 
@@ -220,5 +220,5 @@
                  &     - (1.-unass) * zgrazmf(ji,jj,jk)
                zprcaca = xfracal(ji,jj,jk) * unass * zgrazp(ji,jj,jk)
-#if defined key_trc_dia3d
+#if defined key_diatrc
                prodcal(ji,jj,jk) = prodcal(ji,jj,jk) + zprcaca  ! prodcal=prodcal(nanophy)+prodcal(microzoo)+prodcal(mesozoo)
 #endif
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zmort.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zmort.F90	(revision 2037)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zmort.F90	(revision 2038)
@@ -89,5 +89,5 @@
 
 
-#if defined key_trc_dia3d
+#if defined key_diatrc
      prodcal(:,:,:) = 0.  !: Initialisation of calcite production variable
 #endif
@@ -103,5 +103,5 @@
 !     -----------------------------------------------------------------
                zrespp = wchl * 1.e6 * zstep * xdiss(ji,jj,jk)   &
-# if defined key_off_degrad
+# if defined key_degrad
                   &        * facvol(ji,jj,jk)     &
 # endif
@@ -113,5 +113,5 @@
 !     ----------------------------------------------------------
                ztortp = mprat * zstep * trn(ji,jj,jk,jpphy)          &
-# if defined key_off_degrad
+# if defined key_degrad
                   &          * facvol(ji,jj,jk)     &
 # endif
@@ -130,5 +130,5 @@
                tra(ji,jj,jk,jpnfe) = tra(ji,jj,jk,jpnfe) - zmortp * zfactfe
                zprcaca = xfracal(ji,jj,jk) * zmortp
-#if defined key_trc_dia3d
+#if defined key_diatrc
                prodcal(ji,jj,jk) = prodcal(ji,jj,jk) + zprcaca  ! prodcal=prodcal(nanophy)+prodcal(microzoo)+prodcal(mesozoo)
 #endif
@@ -192,5 +192,5 @@
 
                zrespp2  = 1.e6 * zstep * (  wchl + wchld * ( 1.- xlimdia(ji,jj,jk) )  )    &
-# if defined key_off_degrad
+# if defined key_degrad
                   &       * facvol(ji,jj,jk)       &
 # endif
@@ -201,5 +201,5 @@
 !     ------------------------
                ztortp2  = mprat2 * zstep * trn(ji,jj,jk,jpdia)     &
-# if defined key_off_degrad
+# if defined key_degrad
                   &        * facvol(ji,jj,jk)       &
 # endif
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zopt.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zopt.F90	(revision 2037)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zopt.F90	(revision 2038)
@@ -16,5 +16,4 @@
    USE trc            ! tracer variables
    USE oce_trc        ! tracer-ocean share variables
-   USE trc_oce        ! ocean-tracer share variables
    USE sms_pisces     ! Source Minus Sink of PISCES
    USE iom
@@ -227,5 +226,5 @@
       END DO
 
-#if defined key_trc_diaadd
+#if defined key_diatrc
 # if ! defined key_iomput
       ! save for outputs
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zprod.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zprod.F90	(revision 2037)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zprod.F90	(revision 2038)
@@ -79,5 +79,5 @@
       REAL(wp) ::   zpislopen  , zpislope2n
       REAL(wp) ::   zrum, zcodel, zargu, zvol
-#if defined key_trc_diaadd && defined key_trc_dia3d
+#if defined key_diatrc
       REAL(wp) ::   zrfact2
 #endif
@@ -109,5 +109,5 @@
       ! Computation of the optimal production
 
-# if defined key_off_degrad
+# if defined key_degrad
       prmax(:,:,:) = 0.6 / rday * tgfunc(:,:,:) * facvol(:,:,:)
 # else
@@ -335,5 +335,5 @@
           DO ji = 1, jpi
              zvol = cvol(ji,jj,jk)
-#if defined key_off_degrad
+#if defined key_degrad
              zvol = zvol * facvol(ji,jj,jk)
 #endif
@@ -353,5 +353,5 @@
       ENDIF
 
-#if defined key_trc_diaadd && defined key_trc_dia3d && ! defined key_iomput
+#if defined key_diatrc && ! defined key_iomput
       !   Supplementary diagnostics
       zrfact2 = 1.e3 * rfact2r
@@ -367,5 +367,5 @@
 #endif
 
-#if defined key_trc_diaadd && defined key_trc_dia3d && defined key_iomput
+#if defined key_diatrc && defined key_iomput
       zrfact2 = 1.e3 * rfact2r
       IF ( jnt == nrdttrc ) then
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zrem.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zrem.F90	(revision 2037)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zrem.F90	(revision 2038)
@@ -136,5 +136,5 @@
 !     ----------------------------------------------------------------
                zremik = xremik * xstep / 1.e-6 * xlimbac(ji,jj,jk)         &
-# if defined key_off_degrad
+# if defined key_degrad
                   &            * facvol(ji,jj,jk)              &
 # endif
@@ -172,5 +172,5 @@
 !    ----------------------------------------------------------
                zonitr  = nitrif * xstep * trn(ji,jj,jk,jpnh4) / ( 1.+ emoy(ji,jj,jk) )     &
-# if defined key_off_degrad
+# if defined key_degrad
                   &      * facvol(ji,jj,jk)              &
 # endif
@@ -234,5 +234,5 @@
 !    -------------------------------------------------------------
                zremip = xremip * xstep * tgfunc(ji,jj,jk)   &
-# if defined key_off_degrad
+# if defined key_degrad
                   &            * facvol(ji,jj,jk)              &
 # endif
@@ -289,5 +289,5 @@
                zsatur2 = zsatur * ( 1. + tn(ji,jj,jk) / 400.)**4
                znusil  = 0.225  * ( 1. + tn(ji,jj,jk) / 15.) * zsatur + 0.775 * zsatur2**9
-#    if defined key_off_degrad
+#    if defined key_degrad
                zsiremin = xsirem * xstep * znusil * facvol(ji,jj,jk)
 # else
@@ -350,5 +350,5 @@
 #endif
 
-# if defined key_off_degrad
+# if defined key_degrad
                zscave = zfeequi * zlam1b * xstep  * facvol(ji,jj,jk)
 # else
@@ -374,5 +374,5 @@
 #endif
 
-# if defined key_off_degrad
+# if defined key_degrad
                zaggdfe = zlam1b * xstep * 0.5 * ( trn(ji,jj,jk,jpfer) - zfeequi ) * facvol(ji,jj,jk)
 # else
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zsed.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zsed.F90	(revision 2037)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zsed.F90	(revision 2038)
@@ -93,5 +93,5 @@
       REAL(wp), DIMENSION(jpi,jpj)     ::   zsidep
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   znitrpot, zirondep
-#if defined key_diaadd || defined key_trc_dia3d 
+#if defined key_diatrc 
       REAL(wp) :: zrfact2
 # if defined key_iomput
@@ -286,5 +286,5 @@
                IF( zlim <= 0.2 )   zlim = 0.01
                znitrpot(ji,jj,jk) = MAX( 0.e0, ( 0.6 * tgfunc(ji,jj,jk) - 2.15 ) / rday )   &
-# if defined key_off_degrad
+# if defined key_degrad
                &                  * facvol(ji,jj,jk)   &
 # endif
@@ -325,5 +325,5 @@
       END DO
 
-#if defined key_trc_diaadd || defined key_trc_dia3d
+#if defined key_diatrc
       zrfact2 = 1.e+3 * rfact2r
 #  if  ! defined key_iomput
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zsink.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zsink.F90	(revision 2037)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/p4zsink.F90	(revision 2038)
@@ -97,5 +97,5 @@
       REAL(wp) :: zdiv , zdiv1, zdiv2, zdiv3, zdiv4, zdiv5
       REAL(wp) :: zval1, zval2, zval3, zval4
-#if defined key_trc_diaadd
+#if defined key_diatrc
       REAL(wp) :: zrfact2
       INTEGER  :: ik1
@@ -207,5 +207,5 @@
                      &            * (zfm*xkr_mass_max**2-xkr_mass_min**2)                  &
                      &            * (zeps-1.)**2/(zdiv2*zdiv3))            &
-# if defined key_off_degrad
+# if defined key_degrad
                      &                 *facvol(ji,jj,jk)       &
 # endif
@@ -219,5 +219,5 @@
                      &                    -zfm*xkr_mass_max**3*(1.+3.*((zeps-1.)/           &
                      &                    (zeps-2.)+(zeps-1.)/zdiv3)+(zeps-1.)/zdiv1))      &
-#    if defined key_off_degrad
+#    if defined key_degrad
                      &                 *facvol(ji,jj,jk)             &
 #    endif
@@ -225,5 +225,5 @@
 
                   zagg3 = (  0.163*trn(ji,jj,jk,jpnum)**2*zfm**2*8. * xkr_mass_max**3   &
-#    if defined key_off_degrad
+#    if defined key_degrad
                      &                 *facvol(ji,jj,jk)             &
 #    endif
@@ -242,5 +242,5 @@
                      &                 ((zfm*zfm*xkr_mass_max**2*zsm-xkr_mass_min**2)     &
                      &                 *xkr_eta)/(zdiv*zdiv3*zdiv5) )                     &
-# if defined key_off_degrad
+# if defined key_degrad
                      &                 *facvol(ji,jj,jk)        &
 # endif
@@ -252,5 +252,5 @@
                      &                 /zdiv3-(xkr_mass_min**2-zfm*zsm*xkr_mass_max**2)    &
                      &                 /zdiv)                   &
-# if defined key_off_degrad
+# if defined key_degrad
                      &                 *facvol(ji,jj,jk)        &
 # endif
@@ -266,5 +266,5 @@
                   zaggdoc = ( 0.4 * trn(ji,jj,jk,jpdoc)               &
                      &        + 1018.  * trn(ji,jj,jk,jppoc)  ) * xstep    &
-# if defined key_off_degrad
+# if defined key_degrad
                      &        * facvol(ji,jj,jk)                              &
 # endif
@@ -281,5 +281,5 @@
       END DO
 
-#if defined key_trc_diaadd
+#if defined key_diatrc
       zrfact2 = 1.e3 * rfact2r
       ik1 = iksed + 1
@@ -474,5 +474,5 @@
       REAL(wp) ::   zagg , zaggfe, zaggdoc, zaggdoc2
       REAL(wp) ::   zfact, zwsmax
-#if defined key_trc_dia3d
+#if defined key_diatrc
       REAL(wp) ::   zrfact2
       INTEGER  ::   ik1
@@ -552,5 +552,5 @@
                zfact = xstep * xdiss(ji,jj,jk)
                !  Part I : Coagulation dependent on turbulence
-# if defined key_off_degrad
+# if defined key_degrad
                zagg1 = 940.* zfact * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jppoc) * facvol(ji,jj,jk)
                zagg2 = 1.054e4 * zfact * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jpgoc) * facvol(ji,jj,jk)
@@ -563,5 +563,5 @@
 
                !  Aggregation of small into large particles
-# if defined key_off_degrad
+# if defined key_degrad
                zagg3 = 0.66 * xstep * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jpgoc) * facvol(ji,jj,jk)
                zagg4 = 0.e0 * xstep * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jppoc) * facvol(ji,jj,jk)
@@ -574,5 +574,5 @@
 
                ! Aggregation of DOC to small particles
-#if defined key_off_degrad
+#if defined key_degrad
                zaggdoc = ( 80.* trn(ji,jj,jk,jpdoc) + 698. * trn(ji,jj,jk,jppoc) )       &
                   &      * facvol(ji,jj,jk)  * zfact * trn(ji,jj,jk,jpdoc)
@@ -595,5 +595,5 @@
       END DO
 
-#if defined key_trc_diaadd
+#if defined key_diatrc
       zrfact2 = 1.e3 * rfact2r
       ik1  = iksed + 1
@@ -651,5 +651,5 @@
 
       DO jk = 1, jpkm1
-# if defined key_off_degrad
+# if defined key_degrad
          zwsink2(:,:,jk+1) = -pwsink(:,:,jk) / rday * tmask(:,:,jk+1) * facvol(:,:,jk)
 # else
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/par_pisces.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/par_pisces.F90	(revision 2037)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/par_pisces.F90	(revision 2038)
@@ -30,6 +30,6 @@
    LOGICAL, PUBLIC, PARAMETER ::   lk_kriest     = .TRUE.  !: Kriest flag 
    INTEGER, PUBLIC, PARAMETER ::   jp_pisces     =  23     !: number of passive tracers
-   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_2d  =  13     !: additional 2d output ('key_trc_diaadd')
-   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_3d  =  18     !: additional 3d output ('key_trc_diaadd')
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_2d  =  13     !: additional 2d output ('key_diatrc')
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_3d  =  18     !: additional 3d output ('key_diatrc')
    INTEGER, PUBLIC, PARAMETER ::   jp_pisces_trd =   1     !: number of sms trends for PISCES
 
@@ -68,6 +68,6 @@
    LOGICAL, PUBLIC, PARAMETER ::   lk_kriest     = .FALSE. !: Kriest flag 
    INTEGER, PUBLIC, PARAMETER ::   jp_pisces     = 24      !: number of PISCES passive tracers
-   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_2d  = 13      !: additional 2d output ('key_trc_diaadd')
-   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_3d  = 11      !: additional 3d output ('key_trc_diaadd')
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_2d  = 13      !: additional 2d output ('key_diatrc')
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_3d  = 11      !: additional 3d output ('key_diatrc')
    INTEGER, PUBLIC, PARAMETER ::   jp_pisces_trd =  1      !: number of sms trends for PISCES
 
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/sms_pisces.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/sms_pisces.F90	(revision 2037)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/sms_pisces.F90	(revision 2038)
@@ -62,5 +62,5 @@
    REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xlimbac    !: ??
    REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xdiss      !: ??
-#if defined key_trc_dia3d
+#if defined key_diatrc
    REAL(wp), DIMENSION(jpi,jpj,jpk) ::   prodcal    !: Calcite production
    REAL(wp), DIMENSION(jpi,jpj,jpk) ::   grazing    !: Total zooplankton grazing
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/trcini_pisces.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/trcini_pisces.F90	(revision 2037)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/trcini_pisces.F90	(revision 2038)
@@ -55,11 +55,14 @@
 
 
+      !  Control consitency
+      CALL trc_ctl_pisces
+
+
       IF(lwp) WRITE(numout,*)
       IF(lwp) WRITE(numout,*) ' trc_ini_pisces :   PISCES biochemical model initialisation'
       IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
 
-
       !                                            ! Time-step
-      rfact   = rdttra(1) * float(ndttrc)          ! ---------
+      rfact   = rdttra(1) * float(nn_dttrc)          ! ---------
       rfactr  = 1. / rfact
       rfact2  = rfact / float(nrdttrc)
@@ -128,5 +131,34 @@
       !
    END SUBROUTINE trc_ini_pisces
-   
+ 
+   SUBROUTINE trc_ctl_pisces
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE trc_ctl_pisces  ***
+      !!
+      !! ** Purpose :   control the cpp options, namelist and files 
+      !!----------------------------------------------------------------------
+
+      IF(lwp) WRITE(numout,*)
+      IF(lwp) WRITE(numout,*) ' use PISCES biological model '
+
+   ! Check number of tracers
+   ! -----------------------
+#if  defined key_kriest
+      IF( jp_pisces /= 23) THEN
+#else
+      IF( jp_pisces /= 24) THEN
+#endif
+          IF (lwp) THEN
+              WRITE (numout,*) ' ===>>>> : w a r n i n g '
+              WRITE (numout,*) ' =======   ============= '
+              WRITE (numout,*)                               &
+              &   ' STOP, change jp_pisces',               &
+              &   ' in par_pisces.F90'
+          END IF
+          STOP 'TRC_CTL'
+      END IF
+
+   END SUBROUTINE trc_ctl_pisces
+  
 #else
    !!----------------------------------------------------------------------
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/trcnam_pisces.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/trcnam_pisces.F90	(revision 2038)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/trcnam_pisces.F90	(revision 2038)
@@ -0,0 +1,207 @@
+MODULE trcnam_pisces
+   !!======================================================================
+   !!                      ***  MODULE trcnam_lobster  ***
+   !! TOP :   initialisation of some run parameters for PISCES bio-model
+   !!======================================================================
+   !! History :    -   !  1999-10 (M.A. Foujols, M. Levy) original code
+   !!              -   !  2000-01 (L. Bopp) hamocc3, p3zd
+   !!             1.0  !  2003-08 (C. Ethe)  module F90
+   !!             2.0  !  2007-12  (C. Ethe, G. Madec) from trcnam.pisces.h90
+   !!----------------------------------------------------------------------
+#if defined key_pisces
+   !!----------------------------------------------------------------------
+   !!   'key_pisces'   :                                   PISCES bio-model
+   !!----------------------------------------------------------------------
+   !! trc_nam_pisces       : PISCES model namelist read
+   !!----------------------------------------------------------------------
+   USE oce_trc         ! Ocean variables
+   USE par_trc         ! TOP parameters
+   USE trc             ! TOP variables
+   USE sms_pisces      ! sms trends
+   USE in_out_manager  ! I/O manager
+
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC   trc_nam_pisces   ! called by trcnam.F90 module
+
+
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 2.0 , LOCEAN-IPSL (2007) 
+   !! $Id: trcnam_pisces.F90 1801 2010-01-22 09:36:07Z cetlod $ 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+CONTAINS
+
+   SUBROUTINE trc_nam_pisces
+      !!----------------------------------------------------------------------
+      !!                     ***  trc_nam_pisces  ***  
+      !!
+      !! ** Purpose :   read PISCES namelist
+      !!
+      !! ** input   :   file 'namelist.trc.sms' containing the following
+      !!             namelist: natext, natbio, natsms
+      !!                       natkriest ("key_kriest")
+      !!----------------------------------------------------------------------
+      !!
+#if defined key_diatrc && ! defined key_iomput
+      INTEGER ::  jl, jn
+      ! definition of additional diagnostic as a structure
+      TYPE DIAG
+         CHARACTER(len = 20)  :: snamedia   !: short name
+         CHARACTER(len = 80 ) :: lnamedia   !: long name
+         CHARACTER(len = 20 ) :: unitdia    !: unit
+      END TYPE DIAG
+
+      TYPE(DIAG) , DIMENSION(jp_pisces_2d) :: pisdia2d
+      TYPE(DIAG) , DIMENSION(jp_pisces_3d) :: pisdia3d
+#endif
+
+      NAMELIST/nampisbio/ part, nrdttrc, wsbio, xkmort, ferat3, wsbio2
+#if defined key_kriest
+      NAMELIST/nampiskrp/ xkr_eta, xkr_zeta, xkr_mass_min, xkr_mass_max
+#endif
+#if defined key_diatrc && ! defined key_iomput
+      NAMELIST/nampisdia/ nwritedia, pisdia3d, pisdia2d     ! additional diagnostics
+#endif
+      NAMELIST/nampisdmp/ ln_pisdmp, ln_pisclo
+
+      !!----------------------------------------------------------------------
+
+      IF(lwp) WRITE(numout,*)
+      IF(lwp) WRITE(numout,*) ' trc_nam_pisces : read PISCES namelists'
+      IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
+
+
+      !                               ! Open the namelist file
+      !                               ! ----------------------
+      CALL ctl_opn( numnat, 'namelist_pisces', 'OLD', 'FORMATTED', 'SEQUENTIAL', -1, numout, .FALSE. )
+
+      REWIND( numnat )                    
+      READ  ( numnat, nampisbio )
+
+      IF(lwp) THEN                         ! control print
+         WRITE(numout,*) ' Namelist : nampisbio'
+         WRITE(numout,*) '    part of calcite not dissolved in guts     part      =', part
+         WRITE(numout,*) '    frequence pour la biologie                nrdttrc   =', nrdttrc
+         WRITE(numout,*) '    POC sinking speed                         wsbio     =', wsbio
+         WRITE(numout,*) '    half saturation constant for mortality    xkmort    =', xkmort
+         WRITE(numout,*) '    Fe/C in zooplankton                       ferat3    =', ferat3
+         WRITE(numout,*) '    Big particles sinking speed               wsbio2    =', wsbio2
+      ENDIF
+
+#if defined key_kriest
+
+      !                               ! nampiskrp : kriest parameters
+      !                               ! -----------------------------
+      xkr_eta      = 0.62        
+      xkr_zeta     = 1.62        
+      xkr_mass_min = 0.0002     
+      xkr_mass_max = 1.      
+
+      REWIND( numnat )                     ! read natkriest
+      READ  ( numnat, nampiskrp )
+
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) ' Namelist : nampiskrp'
+         WRITE(numout,*) '    Sinking  exponent                        xkr_eta      = ', xkr_eta
+         WRITE(numout,*) '    N content exponent                       xkr_zeta     = ', xkr_zeta
+         WRITE(numout,*) '    Minimum mass for Aggregates              xkr_mass_min = ', xkr_mass_min
+         WRITE(numout,*) '    Maximum mass for Aggregates              xkr_mass_max = ', xkr_mass_max
+         WRITE(numout,*)
+     ENDIF
+
+
+     ! Computation of some variables
+     xkr_massp = 5.7E-6 * 7.6 * xkr_mass_min**xkr_zeta
+
+#endif
+      !
+#if defined key_diatrc && ! defined key_iomput
+
+      ! Namelist namlobdia
+      ! -------------------
+      nwritedia = 10                   ! default values
+
+      DO jl = 1, jp_pisces_2d
+         jn = jp_pcs0_2d + jl - 1
+         WRITE(ctrc2d(jn),'("2D_",I1)') jn                      ! short name
+         WRITE(ctrc2l(jn),'("2D DIAGNOSTIC NUMBER ",I2)') jn    ! long name
+         ctrc2u(jn) = ' '                                       ! units
+      END DO
+      !                                 ! 3D output arrays
+      DO jl = 1, jp_pisces_3d
+         jn = jp_pcs0_3d + jl - 1
+         WRITE(ctrc3d(jn),'("3D_",I1)') jn                      ! short name
+         WRITE(ctrc3l(jn),'("3D DIAGNOSTIC NUMBER ",I2)') jn    ! long name
+         ctrc3u(jn) = ' '                                       ! units
+      END DO
+
+      REWIND( numnat )               ! read natrtd
+      READ  ( numnat, nampisdia )
+
+      DO jl = 1, jp_pisces_2d
+         jn = jp_pcs0_2d + jl - 1
+         ctrc2d(jn) = pisdia2d(jl)%snamedia
+         ctrc2l(jn) = pisdia2d(jl)%lnamedia
+         ctrc2u(jn) = pisdia2d(jl)%unitdia
+      END DO
+
+      DO jl = 1, jp_pisces_3d
+         jn = jp_pcs0_3d + jl - 1
+         ctrc3d(jn) = pisdia3d(jl)%snamedia
+         ctrc3l(jn) = pisdia3d(jl)%lnamedia
+         ctrc3u(jn) = pisdia3d(jl)%unitdia
+      END DO
+
+      IF(lwp) THEN                   ! control print
+         WRITE(numout,*)
+         WRITE(numout,*) ' Namelist : natadd'
+         WRITE(numout,*) '    frequency of outputs for additional arrays nwritedia = ', nwritedia
+         DO jl = 1, jp_pisces_3d
+            jn = jp_pcs0_3d + jl - 1
+            WRITE(numout,*) '   3d output field No : ',jn
+            WRITE(numout,*) '   short name         : ', TRIM(ctrc3d(jn))
+            WRITE(numout,*) '   long name          : ', TRIM(ctrc3l(jn))
+            WRITE(numout,*) '   unit               : ', TRIM(ctrc3u(jn))
+            WRITE(numout,*) ' '
+         END DO
+
+         DO jl = 1, jp_pisces_2d
+            jn = jp_pcs0_2d + jl - 1
+            WRITE(numout,*) '   2d output field No : ',jn
+            WRITE(numout,*) '   short name         : ', TRIM(ctrc2d(jn))
+            WRITE(numout,*) '   long name          : ', TRIM(ctrc2l(jn))
+            WRITE(numout,*) '   unit               : ', TRIM(ctrc2u(jn))
+            WRITE(numout,*) ' '
+         END DO
+      ENDIF
+#endif
+
+      REWIND( numnat )
+      READ  ( numnat, nampisdmp )
+
+      IF(lwp) THEN                         ! control print
+         WRITE(numout,*)
+         WRITE(numout,*) ' Namelist : nampisdmp'
+         WRITE(numout,*) '    Relaxation of tracer to glodap mean value            ln_pisdmp      =', ln_pisdmp
+         WRITE(numout,*) '    Restoring of tracer to initial value  on closed seas  ln_pisclo      =', ln_pisclo
+         WRITE(numout,*) ' '
+      ENDIF
+
+   END SUBROUTINE trc_nam_pisces
+
+#else
+   !!----------------------------------------------------------------------
+   !!  Dummy module :                                   No PISCES bio-model
+   !!----------------------------------------------------------------------
+CONTAINS
+   SUBROUTINE trc_nam_pisces                      ! Empty routine
+   END  SUBROUTINE  trc_nam_pisces
+#endif  
+
+   !!======================================================================
+END MODULE trcnam_pisces
